#It is called from hampath directory

clear

hampathInstallType=$1
fortranTypeName=`cat install/fortranTypeName.txt`
matlabFileTypeName=`cat install/matlabFileTypeName.txt`
matlabMexTypeName=`cat install/matlabMexTypeName.txt`
hampathExecNameToLink=hampath${hampathInstallType}
hampathExecName=hampath

lignesep="----------------------------------------------------------------------------------------------------"

echo ${lignesep}
echo "--------------------------------------- Hampath installation! --------------------------------------"
echo ""

dateCreation=`date "+%Y %m %d %H %M %S"`

#Installation directory
hampathHome=`pwd`

#Test if there exists a new version of hampath: if there is one then ask to continue
if hash curl 2>/dev/null; then
    adresseversion='http://cots.perso.math.cnrs.fr/hampath/resources/version.txt'
    testCurl=`curl -Is ${adresseversion} | head -n 1 | awk '{print $NF}' | cut -c1,2`
    case "${testCurl}" in
        "") ;;
        *) 
        if [ ${testCurl} = "OK" ]; then
            versionremote=`curl -s ${adresseversion}`
            versionlocale=`cat $hampathHome/install/version/version.txt`
            diff=`expr ${versionremote} - ${versionlocale}`
            if [ ${diff} -gt 0 ]; then
                #adresseversiontext='http://cots.perso.math.cnrs.fr/hampath/resources/versiontext.txt'
                vr=`echo ${versionremote} | sed "s/\([0-9]\)/\1./g"`
                vl=`echo ${versionlocale} | sed "s/\([0-9]\)/\1./g"`
                echo "Installation of HamPath "${vl}
                echo ""
                echo "========= New version ${vr} available! ========="
                echo ""
                echo "Visit http://cots.perso.math.cnrs.fr/hampath for more information on new release."
                echo ""

                fini=false
                while [ $fini = "false" ]; do

                    echo "A new version of hamPath is available! Continue installation?"
                    echo "c) continue"
                    echo "q) quit"

                    read choice
                    case "$choice" in 
                        "c") echo ""
                             fini=true;;
                        "q") exit;;
                        *)   echo "Wrong choice !";;
                    esac

                done

            fi
        fi;;
    esac
fi

#Hampath Version
version=`cat install/version/version.txt`

#Find right OS
os=`uname -a | awk '{print $1}'`
finiOS=true
case "${os}" in 
    "Linux") ;;
    "Darwin") os=Mac;;
    *)  finiOS=false;;
esac
while [ $finiOS = "false" ]; do
    echo "What is your operating system: Linux or Mac!"
    read os
    finiOS=true
    case "${os}" in 
        "Linux") ;;
        "Mac") ;;
        *)  finiOS=false
            echo "Wrong choice for operating system: Linux or Mac!";;
    esac
done

#Find compiler
if [ ${hampathInstallType} = "matlabmex" ]; then
    if hash mex 2>/dev/null; then
        compilo="mex"
    else
        echo "Error during installation: mex command not found! Please check your matlab-mex configuration."
        exit
    fi
else
    #Test si ifort existe
    if hash ifort 2>/dev/null; then
        compilo="ifort"
    else
        #Test si gfortran existe
        if hash gfortran 2>/dev/null; then
            compilo="gfortran"
        else
            #Test si g95 existe
            if hash g95 2>/dev/null; then
                compilo="g95"
            else
                echo "Please give the fortran compiler name for hampath use."
                read compilo
            fi
        fi
    fi
fi

#executable name and test if hampath already exists
if hash ${hampathExecName} 2>/dev/null; then
    fini=false
    while [ $fini = "false" ]; do

        fini=true
        echo "An executable file named ${hampathExecName} already exists! Overwrite it?"
        echo "1 - Yes"
        echo "2 - No and use a different name"
        echo "0 - No and exit"

        wrongChoice=false
        read choice
        case "$choice" in 
            "1") ;;
            "2") echo "Enter the name of the executable file (hampathFortran, hampath2 for example):"
                 read hampathExecName
                 if hash ${hampathExecName} 2>/dev/null; then
                    fini=false
                 fi;;
            "0") exit;;
            *)  wrongChoice=true
                fini=false;;
        esac

        if [ $wrongChoice = "true" ]; then
            echo "Wrong choice !"
        else
            echo ""
            echo "Executable name is: $hampathExecName"
            echo ""
        fi

    done
else
    hampathExecName="hampath"
fi

#Bin directory for executable hampath file
#Si /usr/local/bin est dans le path, c'est bon sinon mettre hampathHome/bin
bindirtolink=${hampathHome}/bin/save
mkdir -p ${bindirtolink}
bindirlink='/usr/local/bin'
testInThePath=`echo ${PATH} | grep ${bindirlink}`
case ${testInThePath} in
    '') isInThePath=false
        bindirlink=${hampathHome}/bin;;
    *)  isInThePath=true;;
esac
tmpFile=hampath-tmp`date "+%Y%m%d%H%M%S"`
touch ${bindirlink}/${tmpFile} 2>/dev/null;
if [ -f ${bindirlink}/${tmpFile} ]; then
    rm ${bindirlink}/${tmpFile}
else
    bindirlink=${hampathHome}/bin
fi

#test if tapenade is already installed
if hash tapenade 2>/dev/null; then
    TAP="tapenade"
else
    echo "Install Tapenade before Hampath!"
    exit
fi

#Summup and possible modification
fini=false
while [ $fini = "false" ]; do

    clear


    echo ${lignesep}
    echo "Your configuration is:"
    echo ""
    echo "1) Operating system detected: " ${os}
    echo "2) Fortran compiler detected: " ${compilo}
    echo "3) Hampath executable name  : " ${hampathExecName}
    echo "4) Put in directory         : " ${bindirlink}
    echo ""
    echo "Would you want to change the configuration? Enter the number corresponding to change option."
    echo ""
    echo "c) Continue installation"
    echo "q) Quit installation"
    echo ""

#on teste s'il est possible d'écrire dans ce répertoire, si oui on teste s'il est dans le path, si oui ok, si non dire de changer ou de le rajouter dans le path
#si pas possible d'ecrire dedans, on demande de changer

    isPossibleToQuit=true
    tmpFile=hampath-tmp`date "+%Y%m%d%H%M%S"`
    touch ${bindirlink}/${tmpFile} 2>/dev/null;
    if [ -f ${bindirlink}/${tmpFile} ]; then
        rm ${bindirlink}/${tmpFile}
        testInThePath=`echo ${PATH} | grep ${bindirlink}":"`
        case ${testInThePath} in
            '') isInThePath=false;;
            *)  isInThePath=true;;
        esac
        if [ ${isInThePath} = "true" ]; then
            echo "Remark: the "${hampathExecName}" command will be put in "${bindirlink}" and will be executable from anywhere in the terminal."
        else
            echo "Remark: the "${bindirlink}" must be contained in the PATH variable to make the "${hampathExecName}" command executable!"
            echo ""
            echo "    a) Either change the bin directory using command 4, for a directory in the PATH="${PATH}
            echo ""
            echo " or"
            echo ""
            echo "    b) To make the "${hampathExecName}" command executable, please:"
            echo "        - For BASH environment, open your ~/.bashrc file and add the line: export PATH=\$PATH:"${bindirlink}
            echo "        - For CSH  environment, open your ~/.csshrc file and add the line: setenv PATH '\$PATH:${bindirlink}'"
            echo ""
            echo "       At the end of the installation, open a new terminal or type: source ~/.bashrc or ~/.cshrc, to take into account the modifications."
        fi
    else
        isPossibleToQuit=false
        echo "Remark: no writing access to "${bindirlink}", please change the bin directory using command 4!"
    fi

    echo ""
    echo ${lignesep}
    echo ""

    read choice
    case "$choice" in 
        "1") echo "Operating sytem : Linux or Mac?"
             finiOS=false
             while [ $finiOS = "false" ]; do
                read os
                finiOS=true
                case "${os}" in 
                    "Linux")  ;;
                    "Mac")    ;;
                    *)  finiOS=false
                        echo "Wrong choice for operating system: Linux or Mac!";;
                esac
             done
            ;;
        "2")    echo "Enter the name of the fortran compiler you want to use."
                read compilo
                ;;
        "3")    echo "Enter the name of the executable file (hampathV2 or hampathMatlab for example):"
                read hampathExecName;;
        "4")    echo "Enter the absolute path of directory where the executable link is put."
                read bindirlink
                while [ ! -d ${bindirlink} ]; do
                    echo "Path directory does not exist! Enter a valid absolute path. "
                    read bindirlink
                done
                ;;
        "c") if [ ${isPossibleToQuit} = "true" ]; then
                 fini=true
             else
                 echo "You must first change the bin directory!"
             fi;;
        "q") exit;;
        *)   echo "Wrong choice !";;
    esac
done

#Creation of makefile.rule
mkdir -p ${hampathHome}/lib
fileRule=${hampathHome}/lib/makefile${hampathInstallType}.rule
echo "################################################# "       >  ${fileRule}
echo "#Rule created by hampath on " ${dateCreation}             >> ${fileRule}
echo "################################################# "       >> ${fileRule}

echo "hampathHome="${hampathHome}           >> ${fileRule}
echo "version="${version}                   >> ${fileRule}
echo "os="${os}                             >> ${fileRule}
echo "compilo="${compilo}                   >> ${fileRule}
echo "hampathExecName="${hampathExecName}   >> ${fileRule}
echo "bindirlink="${bindirlink}             >> ${fileRule}
echo "TAP="${TAP}                           >> ${fileRule}

#Testing official mexfiles
fini=false
if [ ${hampathInstallType} = ${matlabMexTypeName} ]; then
    if hash mex 2>/dev/null; then
        if hash matlab 2>/dev/null; then
            echo ""
            echo ${lignesep}
            echo "Testing mex configuration with official mex-files from 'http://www.mathworks.fr/fr/help/matlab/matlab_external/table-of-mex-examples.html'!"
            echo "Matlab will be launch and res should be equal to 9."
            echo ""
            if make -f install/makefile --silent hampathHome=${hampathHome} hampathExecNameToLink=${hampathExecNameToLink} hampathInstallType=${hampathInstallType} testingCMD
            then
                echo ""
                echo "Testing is complete!"
                echo ""
            else
                echo ""
                echo "Testing failed! Please check you mex configuration before installing Hampath."
                echo "Visit 'http://www.mathworks.fr/fr/help/matlab/ref/mex.html' for information."
                echo ""
                echo "Remark 1: You can also try to install the Matlab / Octave version using the 'installMatlabOctave.sh' script."
                echo "\t This will install a Matlab / Octave version without any use of mex-files. It can be less efficient than mex version."
                echo ""
                echo "Remark 2: The HAMPATH package uses the mex command to compile the FORTRAN sources in order to make some functions callable by MATLAB."
                echo "\t It can be possible that the mex command is not from MATLAB but LATEX."
                echo "\t Type 'which mex' in the shell and if you get something like '/usr/texbin/mex' then you don’t have the right mex command."
                echo "\t To fix this problem, open your .login (or .profile or .cshrc or .bashrc ...) file present in your home directory,"
                echo "\t and add the MATLAB bin absolute path in the environment variable PATH according to:"
                echo "\t setenv PATH '\$MATLAB_HOME/bin:\$PATH' (csh)"
                echo "\t or"
                echo "\t export PATH=\$MATLAB_HOME/bin:\$PATH (bash), where MATLAB_HOME is the MATLAB absolute path."
                echo ""
                fini=true
            fi
            echo ${lignesep}
            echo ""
        else
            echo ""
            echo ${lignesep}
            echo ""
            echo "It is impossible to test your mex configuration since matlab command does not exist!"
            echo "Installation continues but hampath execution can fail."
            echo ""
            echo "You can try to install the Matlab / Octave version using the 'installMatlabOctave.sh' script if installation will not be complete."
            echo "This will install a Matlab / Octave version without any use of mex-files. It can be less efficient than mex version."
            echo ""
            echo ""
            echo ${lignesep}
            echo ""
        fi
    else
        echo ""
        echo ${lignesep}
        echo ""
        echo "It is impossible to test your mex configuration since mex command does not exist!"
        echo "Installation will stop since the mex command is required."
        echo "Visit 'http://www.mathworks.fr/fr/help/matlab/ref/mex.html' for information."
        echo ""
        echo "You can also try to install the Matlab / Octave version using the 'installMatlabOctave.sh' script."
        echo "This will install a Matlab / Octave version without any use of mex-files. It can be less efficient than mex version."
        echo ""
        echo ${lignesep}
        echo ""
        fini=true
    fi
fi

#Erase contains in directory, copy all files in it, compile and clean
if [ ${fini} = "false" ]; then
    if make -f install/makefile --silent hampathHome=${hampathHome} hampathExecNameToLink=${hampathExecNameToLink} hampathInstallType=${hampathInstallType} installCMD
    then
        echo ""
        echo "Installation is complete!"
        echo ""
        #Testing
        if [ ${hampathInstallType} != ${matlabMexTypeName} ]; then
            if make -f install/makefile --silent hampathHome=${hampathHome} hampathExecNameToLink=${hampathExecNameToLink} hampathInstallType=${hampathInstallType} testingCMD
            then
                echo ""
                echo "Testing is complete!"
                echo ""
            else
                echo ""
                echo "Testing failed!"
                echo ""
                fini=true
            fi
        fi
    else
        echo ""
        echo "Installation failed! If you see 'Permission denied' then try 'sudo install.sh'."
        echo ""
        fini=true
    fi
fi

#Give the advice to run hampath example
if [ ${fini} = "false" ]; then

    #Create hampath executable with hampathHome directory mentioned in it
    binfiletolink=${bindirtolink}/${hampathExecNameToLink}
    echo "#!/bin/sh"                            >   ${binfiletolink}
    echo "clear"                                >>  ${binfiletolink}
    echo "hampathHome="${hampathHome}           >>  ${binfiletolink}
    echo "hampathInstallType="${hampathInstallType} >>  ${binfiletolink}
    #cat ${hampathHome}/install/bin/version.sh   >>  ${binfiletolink}
    if [ ${hampathInstallType} = ${fortranTypeName} ]; then
        cat ${hampathHome}/install/bin/hampathFortran.sh   >>  ${binfiletolink}
    elif [ ${hampathInstallType} = ${matlabFileTypeName} ]; then
        cat ${hampathHome}/install/bin/hampathMatlab.sh    >>  ${binfiletolink}
    elif [ ${hampathInstallType} = ${matlabMexTypeName} ]; then
        cat ${hampathHome}/install/bin/hampathMatlabMex.sh >> ${binfiletolink}
    fi
    chmod 755                                       ${binfiletolink}
    #Put hampath executable to bin directory
    rm -f ${bindirlink}/${hampathExecName}
    ln -s ${binfiletolink} ${bindirlink}/${hampathExecName} 2>/dev/null;

    if [ ${hampathInstallType} = ${fortranTypeName} ]; then
        echo ${lignesep}
        echo ""
        echo "Create a directory for the example and place you into it."
        echo "\t try: ${hampathExecName} -newSimpleShooting, to copy all files concerning the simple shooting example,"
        echo "\t or   ${hampathExecName} -newMultipleShooting, for multiple shooting example."
        echo "Then try: ${hampathExecName} main.f90, to compile the problem."
        echo "And try: main, to execute it."
        echo ""
        echo "Try: ${hampathExecName} -help, for information."
        echo ""
    fi
    if [ ${hampathInstallType} = ${matlabFileTypeName} -o ${hampathInstallType} = ${matlabMexTypeName} ]; then
        echo ${lignesep}
        echo ""
        echo "Create a directory for the example and place you into it."
        echo "\t try: ${hampathExecName} -newSimpleShooting, to copy all files concerning the simple shooting example,"
        echo "\t or   ${hampathExecName} -newMultipleShooting, for multiple shooting example."
        echo "Then try: ${hampathExecName}, to compile the problem."
        echo "And try to execute the main script main.m."
        echo ""
        echo "Try: ${hampathExecName} -help, for information."
        echo ""
    fi
fi

#---------------------------------------------------------------------------------------------------------------------------------------------------------#
#---------------------------------------------------------------------------------------------------------------------------------------------------------#
# Written on 2009-2013
# by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis

