!!********************************************************************
!!
!!     Subroutine printandstop 
!!
!>     \ingroup commonUtils
!!     \brief  Print message and then stop execution of the program.
!!       \param[in] message Message to print
!!
!!  \author Olivier Cots
!!  \date   2009-2013
!!  \copyright Eclipse Public License
    subroutine printandstop(message)
        implicit none
        character (LEN=*), intent(in)   :: message

#if defined(InterfaceFortran)
        write(*,'(a)',advance='yes') trim(message)
        write(*,*) ''
        stop
#endif

#if defined(InterfaceMatlab)
        call MEXERRMSGTXT(trim(message))
#endif

    end subroutine printandstop

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!
