      SUBROUTINE HYBRDFUN(N, X, Y, IFLAG)
      IMPLICIT NONE
C     Written on Thu 12 Jun 2008 14:57:08 CEST
C     by Jean-Baptiste Caillau - Math. Institute, Bourgogne Univ.
C
C     Function y = nlefun(x, p1, ...). HYBRD function argument.
C     Matlab gateway.

C     .. Global ..
#include "fintrf.h"
      INTEGER          NVINMAX
      PARAMETER       (NVINMAX = 32)
      INTEGER          NVIN
      MWPOINTER        MXVIN(NVINMAX)
      INTEGER          NFEV2
      CHARACTER*32     NLEFUN

      COMMON           /CNVIN/NVIN
      COMMON           /CMXVIN/MXVIN
      COMMON           /CNFEV2/NFEV2
      COMMON           /CNLEFUN/NLEFUN

C     .. Arguments ..
C     N                (input) INTEGER
C                      Dimension
C     X                (input) DOUBLE PRECISION array, dimension N
C                      Argument
C     Y                (output) DOUBLE PRECISION array, dimension N
C                      Result
C     IFLAG            (input) INTEGER
C                      Solver flag
      INTEGER          N
      INTEGER          IFLAG
      DOUBLE PRECISION X(N)
      DOUBLE PRECISION Y(N)

C     .. Local declarations ..
      INTEGER          NLHS0
      PARAMETER       (NLHS0 = 1)
      INTEGER          NRHS0
      PARAMETER       (NRHS0 = 1)
      INTEGER          NRHS
      INTEGER          NLHS
      MWPOINTER        PLHS(NLHS0)
      MWPOINTER        PRHS(NRHS0 + NVINMAX)
      MWPOINTER        PX
      MWPOINTER        PY
      INTEGER          RET
      INTEGER          MXGETM
      INTEGER          MXGETN
      MWPOINTER        MXGETPR
      MWPOINTER        MXCREATEDOUBLEMATRIX
      INTEGER          MEXCALLMATLAB
      INTEGER          I
      DOUBLE PRECISION DNRM2

C     .. First executable statement ..
      NRHS = NRHS0 + NVIN
      PRHS(1) = MXCREATEDOUBLEMATRIX(N, 1, 0)
      PX = MXGETPR(PRHS(1))
      CALL MXCOPYREAL8TOPTR(X, PX, N)

      DO I = 1, NVIN
        PRHS(NRHS0 + I) = MXVIN(I)
      END DO

      NLHS = NLHS0

      RET = MEXCALLMATLAB(NLHS, PLHS, NRHS, PRHS, NLEFUN)
      IF (RET.NE.0) THEN
        CALL MEXERRMSGTXT('Problem calling nlefun.')
      END IF
      NFEV2 = NFEV2 + 1

      IF (MXGETM(PLHS(1)) * MXGETN(PLHS(1)).NE.N) THEN
        CALL MEXERRMSGTXT('nlefun result has wrong dimension.')
      ENDIF
      PY = MXGETPR(PLHS(1))
      CALL MXCOPYPTRTOREAL8(PY, Y, N)

      WRITE(*, '(    i6, $)') NFEV2
      WRITE(*, '(e23.15, $)') DNRM2(N, Y, 1)
      WRITE(*, '(e23.15, $)') DNRM2(N, X, 1)
C      DO I = 1, N
C        WRITE(*, '( e11.3, $)') X(I)
C      END DO
      WRITE(*, *) ''

      RETURN
      END

