        program dhvfunTest
            use mod_dhvfun
            implicit none

        !1a) dhvfun is call for a single time and a single Jacobi field

            double precision                 :: t1a
            double precision,  dimension(4)  :: z1a
            double precision,  dimension(4)  :: dz1a
            double precision,  dimension(6)  :: par1a
            double precision,  dimension(4)  :: hv1a
            double precision,  dimension(4)  :: dhv1a

        !1b) dhvfun is call for a single time and several Jacobi fields

            double precision                   :: t1b
            double precision,  dimension(4)    :: z1b
            double precision,  dimension(4,4)  :: dz1b
            double precision,  dimension(6)    :: par1b
            double precision,  dimension(4)    :: hv1b
            double precision,  dimension(4,4)  :: dhv1b

        !1c) dhvfun is call for several times and several Jacobi fields

            double precision,  dimension(2)    :: t1c
            double precision,  dimension(4,2)  :: z1c
            double precision,  dimension(4,2)  :: dz1c
            double precision,  dimension(6)    :: par1c
            double precision,  dimension(4,2)  :: hv1c
            double precision,  dimension(4,2)  :: dhv1c

        !2a) dhvfun is call for a single time and a single Jacobi field

            double precision                 :: t2a
            double precision,  dimension(4)  :: z2a
            double precision,  dimension(4)  :: dz2a
            double precision,  dimension(2)  :: ti2a
            double precision,  dimension(6)  :: par2a
            double precision,  dimension(4)  :: hv2a
            double precision,  dimension(4)  :: dhv2a

        !2b) dhvfun is call for a single time and several Jacobi fields

            double precision                   :: t2b
            double precision,  dimension(4)    :: z2b
            double precision,  dimension(4,4)  :: dz2b
            double precision,  dimension(2)    :: ti2b
            double precision,  dimension(6)    :: par2b
            double precision,  dimension(4)    :: hv2b
            double precision,  dimension(4,4)  :: dhv2b

        !2c) dhvfun is call for several times and several Jacobi fields

            double precision,  dimension(2)    :: t2c
            double precision,  dimension(4,2)  :: z2c
            double precision,  dimension(4,2)  :: dz2c
            double precision,  dimension(2)    :: ti2c
            double precision,  dimension(6)    :: par2c
            double precision,  dimension(4,2)  :: hv2c
            double precision,  dimension(4,2)  :: dhv2c

            double precision,  dimension(4,4)  :: I4
            logical :: erreur
            integer :: i

            I4 = 0d0
            do i=1,4
                I4(i,i) = 1d0
            end do

            erreur = .false.

        !1a) dhvfun is call for a single time and a single Jacobi field
            t1a     = 0d0
            z1a     = (/ -1d0, -1d0, 1d0, 2d0 /)
            dz1a    = I4(:,2)
            par1a   = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
            call dhvfun(t1a,z1a,dz1a,par1a,hv1a,dhv1a)

            if(.not.(hv1a(1).eq.-1d0 .and. hv1a(2).eq.-9d0 .and. hv1a(3).eq.0d0 .and. hv1a(4).eq.-41d0))then
                erreur = .true.
            end if

            if(.not.(dhv1a(1).eq.1d0))then
                erreur = .true.
            end if

            if(.not.(dhv1a(2).eq.20d0))then
                erreur = .true.
            end if

            if(.not.(dhv1a(3).eq.0d0))then
                erreur = .true.
            end if

            if(.not.(dhv1a(4).eq.40d0))then
                erreur = .true.
            end if

        !1b) dhvfun is call for a single time and several Jacobi fields
            t1b     = 0d0
            z1b     = (/ -1d0, -1d0, 1d0, 2d0 /)
            dz1b    = I4
            par1b   = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
            call dhvfun(t1b,z1b,dz1b,par1b,hv1b,dhv1b)

            if(.not.(hv1b(1).eq.-1d0 .and. hv1b(2).eq.-9d0 .and. hv1b(3).eq.0d0 .and. hv1b(4).eq.-41d0))then
                erreur = .true.
            end if

            if(.not.(dhv1b(1,1).eq.0d0 .and. dhv1b(1,2).eq.1d0 .and. dhv1b(1,3).eq.0d0 .and. dhv1b(1,4).eq.0d0))then
                erreur = .true.
            end if

            if(.not.(dhv1b(2,1).eq.0d0 .and. dhv1b(2,2).eq.20d0 .and. dhv1b(2,3).eq.0d0 .and. dhv1b(2,4).eq.0.5d0))then
                erreur = .true.
            end if

            if(.not.(dhv1b(3,1).eq.0d0 .and. dhv1b(3,2).eq.0d0 .and. dhv1b(3,3).eq.0d0 .and. dhv1b(3,4).eq.0d0))then
                erreur = .true.
            end if

            if(.not.(dhv1b(4,1).eq.0d0 .and. dhv1b(4,2).eq.40d0 .and. dhv1b(4,3).eq.-1d0 .and. dhv1b(4,4).eq.-20d0))then
                erreur = .true.
            end if

        !1c) dhvfun is call for several times and several Jacobi fields

            t1c         = (/0d0, 1d0/)
            z1c(:,1)    = (/ -1d0, -1d0, 1d0, 2d0 /)
            z1c(:,2)    = (/ -1d0, -1d0, 1d0, 2d0 /)
            dz1c        = I4(:,1:2)
            par1c       = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
            call dhvfun(t1c,z1c,dz1c,par1c,hv1c,dhv1c)

            if(.not.(hv1c(1,1).eq.-1d0 .and. hv1c(2,1).eq.-9d0 .and. hv1c(3,1).eq.0d0 .and. hv1c(4,1).eq.-41d0))then
                erreur = .true.
            end if

            if(.not.(hv1c(1,2).eq.-1d0 .and. hv1c(2,2).eq.-9d0 .and. hv1c(3,2).eq.0d0 .and. hv1c(4,2).eq.-41d0))then
                erreur = .true.
            end if

            if(.not.(dhv1c(1,1).eq.0d0 .and. dhv1c(1,2).eq.1d0  ))then
                erreur = .true.
            end if

            if(.not.(dhv1c(2,1).eq.0d0 .and. dhv1c(2,2).eq.20d0 ))then
                erreur = .true.
            end if

            if(.not.(dhv1c(3,1).eq.0d0 .and. dhv1c(3,2).eq.0d0  ))then
                erreur = .true.
            end if

            if(.not.(dhv1c(4,1).eq.0d0 .and. dhv1c(4,2).eq.40d0 ))then
                erreur = .true.
            end if

        !2a) dhvfun is call for a single time and a single Jacobi field
            t2a     = 0d0
            ti2a    = (/0d0,10d0/)
            z2a     = (/ -1d0, -1d0, 1d0, 2d0 /)
            dz2a    = I4(:,2)
            par2a   = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
            call dhvfun(t2a,z2a,dz2a,ti2a,par2a,hv2a,dhv2a)

            if(.not.(hv2a(1).eq.-1d0 .and. hv2a(2).eq.-9d0 .and. hv2a(3).eq.0d0 .and. hv2a(4).eq.-41d0))then
                erreur = .true.
            end if

            if(.not.(dhv2a(1).eq.1d0))then
                erreur = .true.
            end if

            if(.not.(dhv2a(2).eq.20d0))then
                erreur = .true.
            end if

            if(.not.(dhv2a(3).eq.0d0))then
                erreur = .true.
            end if

            if(.not.(dhv2a(4).eq.40d0))then
                erreur = .true.
            end if

        !2b) dhvfun is call for a single time and several Jacobi fields
            t2b     = 0d0
            ti2b    = (/0d0,10d0/)
            z2b     = (/ -1d0, -1d0, 1d0, 2d0 /)
            dz2b    = I4
            par2b   = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
            call dhvfun(t2b,z2b,dz2b,ti2b,par2b,hv2b,dhv2b)

            if(.not.(hv2b(1).eq.-1d0 .and. hv2b(2).eq.-9d0 .and. hv2b(3).eq.0d0 .and. hv2b(4).eq.-41d0))then
                erreur = .true.
            end if

            if(.not.(dhv2b(1,1).eq.0d0 .and. dhv2b(1,2).eq.1d0 .and. dhv2b(1,3).eq.0d0 .and. dhv2b(1,4).eq.0d0))then
                erreur = .true.
            end if

            if(.not.(dhv2b(2,1).eq.0d0 .and. dhv2b(2,2).eq.20d0 .and. dhv2b(2,3).eq.0d0 .and. dhv2b(2,4).eq.0.5d0))then
                erreur = .true.
            end if

            if(.not.(dhv2b(3,1).eq.0d0 .and. dhv2b(3,2).eq.0d0 .and. dhv2b(3,3).eq.0d0 .and. dhv2b(3,4).eq.0d0))then
                erreur = .true.
            end if

            if(.not.(dhv2b(4,1).eq.0d0 .and. dhv2b(4,2).eq.40d0 .and. dhv2b(4,3).eq.-1d0 .and. dhv2b(4,4).eq.-20d0))then
                erreur = .true.
            end if

        !2c) dhvfun is call for several times and several Jacobi fields
            t2c         = (/0d0, 1d0/)
            ti2c        = (/0d0,10d0/)
            z2c(:,1)    = (/ -1d0, -1d0, 1d0, 2d0 /)
            z2c(:,2)    = (/ -1d0, -1d0, 1d0, 2d0 /)
            dz2c        = I4(:,1:2)
            par2c       = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
            call dhvfun(t2c,z2c,dz2c,ti2c,par2c,hv2c,dhv2c)

            if(.not.(hv2c(1,1).eq.-1d0 .and. hv2c(2,1).eq.-9d0 .and. hv2c(3,1).eq.0d0 .and. hv2c(4,1).eq.-41d0))then
                erreur = .true.
            end if

            if(.not.(hv2c(1,2).eq.-1d0 .and. hv2c(2,2).eq.-9d0 .and. hv2c(3,2).eq.0d0 .and. hv2c(4,2).eq.-41d0))then
                erreur = .true.
            end if

            if(.not.(dhv2c(1,1).eq.0d0 .and. dhv2c(1,2).eq.1d0  ))then
                erreur = .true.
            end if

            if(.not.(dhv2c(2,1).eq.0d0 .and. dhv2c(2,2).eq.20d0 ))then
                erreur = .true.
            end if

            if(.not.(dhv2c(3,1).eq.0d0 .and. dhv2c(3,2).eq.0d0  ))then
                erreur = .true.
            end if

            if(.not.(dhv2c(4,1).eq.0d0 .and. dhv2c(4,2).eq.40d0 ))then
                erreur = .true.
            end if

            if(erreur)then
                write(*,*) "   dhvfun    test failed!"
            else
                write(*,*) "   dhvfun    test ok!"
            end if

        end program dhvfunTest

        !!******************************************************************************************!!
        ! Written on 2014                                                                           !!
        ! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
        !!******************************************************************************************!!

