program expdhvfunTest
    use mod_expdhvfun
    implicit none

    double precision                                :: tspan(2), z0(4), dz0(4,2), zf(4), dzf(4,2)
    double precision                                :: zfEtalon(4), dzfEtalon(4,2)
    double precision                                :: tspanBis(11), ti(2), par(6), res
    type(TOptions)                                  :: options
    double precision, allocatable, dimension(:)     :: tout
    double precision, allocatable, dimension(:,:)   :: z,dz
    integer                                         :: flag,i,k
    logical                                         :: erreur

    !Affichage des options
!optionsDefaut (Matlab) =
!            Derivative: 'eqvar'
!              DispIter: 1
!               Display: 'on'
!            DoSavePath: 'off'
!         FreeFinalTime: 'false'
!                 MaxSf: 100000
!           MaxSfunNorm: 0.100000000000000
!           MaxStepsOde: 100000
!        MaxStepsOdeHam: 100000
!        MaxStepSizeOde: 0
!     MaxStepSizeOdeHam: 0
!                   ODE: 'dopri5'
!                ODEHam: 'dopri5'
!    StopAtTurningPoint: 0
!             TolOdeAbs: 1.000000000000000e-14
!             TolOdeRel: 1.000000000000000e-08
!          TolOdeHamAbs: 1.000000000000000e-14
!          TolOdeHamRel: 1.000000000000000e-08
!        TolDenseHamEnd: 1.000000000000000e-08
!          TolDenseHamX: 1.000000000000000e-08
!            TolScaling: 1.000000000000000e-05
!                  TolX: 1.000000000000000e-08

!    call printOptions(options)

    !exphvfunSimple
    tspan = (/ 0d0, 0.1d0 /)
    tspanBis = (/ 0d0, 0.01d0, 0.02d0, 0.03d0, 0.04d0, 0.05d0, 0.06d0, 0.07d0, 0.08d0, 0.09d0, 0.1d0 /)
    z0    = (/ -1d0, -1d0, 1d0, 2d0 /)
    dz0   = 0d0; dz0(3,1) = 1d0; dz0(4,2) = 1d0;
    par   = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
    call expdhvfun(tspanBis, z0, dz0, options, par, tout, z, dz, flag)

    !hvfunMultiple
    ti    = tspan
    call expdhvfun(tspan, z0, dz0, ti, options, par, tout, z, dz, flag)

    zfEtalon = (/ -1.391637858354299d0, -48.968474123674980d0, 1.000000000000000d0, -0.001208071029310d0 /)

    dzfEtalon(1,:) = (/ -0.001287177269712d0,   0.051059756290173d0 /)
    dzfEtalon(2,:) = (/ -0.652078388809058d0,  25.646770773205123d0 /)
    dzfEtalon(3,:) = (/                  1d0,                   0d0 /)
    dzfEtalon(4,:) = (/ -0.001995446730827d0,   0.000179441450227d0 /)

    k   = 2
    zf  = z(:,size(tout))
    dzf = dz(:,k*size(tout)-1:k*size(tout))

    res = 0d0
    do i=1,size(z0)
        res = res + abs(zf(i)-zfEtalon(i))**2 + abs(dzf(i,1)-dzfEtalon(i,1))**2 + abs(dzf(i,2)-dzfEtalon(i,2))**2
    end do
    res = sqrt(res)

    erreur = .false.
    if(.not.(res.lt.1d-8))then
        erreur = .true.
    end if

    if(erreur)then
        write(*,*) "   expdhvfun test failed!"
    else
        write(*,*) "   expdhvfun test ok!"
    end if

!    write(*,*) "   res = ", res
!    write(*,*) "   zf1 = ", zf(1)
!    write(*,*) "   zf2 = ", zf(2)
!    write(*,*) "   zf3 = ", zf(3)
!    write(*,*) "   zf4 = ", zf(4)

    deallocate(tout,z,dz)

end program expdhvfunTest

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!
