program hampathTest
    use mod_hampath
    implicit none

    double precision,  dimension(6,2)              :: parspan
    double precision,  dimension(2)                :: ti
    double precision,  dimension(4)                :: z0
    type(TOptions)                                 :: options
    double precision,  dimension(:,:), allocatable :: parout
    double precision,  dimension(:),   allocatable :: tiout
    double precision,  dimension(:,:), allocatable :: ziout
    double precision,  dimension(:),   allocatable :: sout
    double precision,  dimension(:,:), allocatable :: viout
    double precision,  dimension(:),   allocatable :: dets
    double precision,  dimension(:),   allocatable :: normS
    double precision,  dimension(:),   allocatable :: ps
    integer                                       :: flag

    double precision                                :: z0f(4), z0fEtalon(4), res
    integer                                         :: i
    logical                                         :: erreur

    !call printOptions(options)
    call setOption(options,'Display','off')

    ti           = (/ 0d0, 1d0 /)
    z0           = (/ -1d0, -1d0, 36d0, 20d0 /)
    parspan(:,1) = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 0d0/)
    parspan(:,2) = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 1d0/)
    call hampath(parspan,ti,z0,options,parout,tiout,ziout,sout,viout,dets,normS,ps,flag)

    z0f       = ziout(:,size(sout))
    z0fEtalon = (/ -1d0, -1d0, 47.435672379440419d0, 23.978907872296855d0 /)

    res = 0d0
    do i=1,size(z0)
        res = res + abs(z0f(i)-z0fEtalon(i))**2
    end do
    res = sqrt(res)

    erreur = .false.
    if(.not.(res.lt.1d-7))then
        erreur = .true.
    end if

    if(erreur)then
        write(*,*) "   hampath   test failed!"
    else
        write(*,*) "   hampath   test ok!"
    end if

    deallocate(parout,tiout,ziout,sout,viout,dets,normS,ps)

end program hampathTest

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!



