program hfunTest
    use mod_hamfun
    implicit none

    double precision t, z(4), par(6), h
    double precision t2(2), z2(4,2), h2(2)
    double precision hm1, hm2(2), ti(2)

    !hamfunSimpleSingle
    t   =     0d0
    z   = (/ -1d0, -1d0, 1d0, 2d0 /)
    par = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
    call hamfun(t,z,par,h)

    !hamfunSimple
    t2(1)   = t
    t2(2)   = t
    z2(:,1) = z
    z2(:,2) = z
    call hamfun(t2,z2,par,h2)

    !hamfunMultipleSingle
    ti = (/ t, t+1d0 /)
    call hamfun(t,z,ti,par,hm1)

    !hamfunMultiple
    call hamfun(t2,z2,ti,par,hm2)

    if(h.eq.-20d0 .and. h2(1).eq.-20d0 .and. h2(2).eq.-20d0 .and. hm1.eq.-20d0 .and. hm2(1).eq.-20d0 .and. hm2(2).eq.-20d0)then
        write(*,*) "   hfun      test ok!"
    else
        write(*,*) "   hfun      test failed!"
    end if

end program hfunTest

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!
