program hvfunTest
    use mod_hvfun
    implicit none

    double precision t, z(4), par(6), hv(4)
    double precision t2(2), z2(4,2), hv2(4,2)
    double precision hvm1(4), hvm2(4,2), ti(2)
    logical erreur

    !hvfunSimpleSingle
    t   =     0d0
    z   = (/ -1d0, -1d0, 1d0, 2d0 /)
    par = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
    call hvfun(t,z,par,hv)

    !hvfunSimple
    t2(1)   = t
    t2(2)   = t
    z2(:,1) = z
    z2(:,2) = z
    call hvfun(t2,z2,par,hv2)

    !hvfunMultipleSingle
    ti = (/ t, t+1d0 /)
    call hvfun(t,z,ti,par,hvm1)

    !hvfunMultiple
    call hvfun(t2,z2,ti,par,hvm2)

    erreur = .false.

    if(.not.(hv(1).eq.-1d0 .and. hv(2).eq.-9d0 .and. hv(3).eq.0d0 .and. hv(4).eq.-41d0))then
        erreur = .true.
    end if

    if(.not.(hv2(1,1).eq.-1d0 .and. hv2(2,1).eq.-9d0 .and. hv2(3,1).eq.0d0 .and. hv2(4,1).eq.-41d0))then
        erreur = .true.
    end if
    if(.not.(hv2(1,2).eq.-1d0 .and. hv2(2,2).eq.-9d0 .and. hv2(3,2).eq.0d0 .and. hv2(4,2).eq.-41d0))then
        erreur = .true.
    end if

    if(.not.(hvm1(1).eq.-1d0 .and. hvm1(2).eq.-9d0 .and. hvm1(3).eq.0d0 .and. hvm1(4).eq.-41d0))then
        erreur = .true.
    end if

    if(.not.(hvm2(1,1).eq.-1d0 .and. hvm2(2,1).eq.-9d0 .and. hvm2(3,1).eq.0d0 .and. hvm2(4,1).eq.-41d0))then
        erreur = .true.
    end if
    if(.not.(hvm2(1,2).eq.-1d0 .and. hvm2(2,2).eq.-9d0 .and. hvm2(3,2).eq.0d0 .and. hvm2(4,2).eq.-41d0))then
        erreur = .true.
    end if

!    write(*,*) "Hv   = ", hv
!    write(*,*) "Hv2  = ", hv2
!    write(*,*) "Hvm1 = ", hvm1
!    write(*,*) "Hvm2 = ", hvm2

    if(erreur)then
        write(*,*) "   hvfun     test failed!"
    else
        write(*,*) "   hvfun     test ok!"
    end if

end program hvfunTest

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!
