program hybrdTest
    use mod_hybrd
    implicit none

    double precision    :: x(1), y(1), xsol(1), fxsol(1)
    integer             :: nfev, flag, n


    external fun

    n = 1
    x = 1d0
    call hybrd(fun,n,x,1d-8,100,nfev,xsol,fxsol,flag)

    if(abs(xsol(1)-0.5d0).lt.1d-10)then
        write(*,*) "   hybrd     test ok!"
    else
        write(*,*) "   hybrd     test failed!"
    end if

end program hybrdTest

Subroutine fun(n,x,fvec,iflag)
    implicit none
    integer,            intent(in)                        :: n
    double precision,   intent(in),  dimension(n)         :: x
    double precision,   intent(out), dimension(n)         :: fvec
    integer,            intent(inout)                     :: iflag

    DOUBLE PRECISION DNRM2

    !iflag = 0 : beginning
    !iflag = 1 : each iter and 11 on second call of each iter
    !iflag = 2 : jacobian called
    !iflag = 3 : end

!    if(iflag.eq.0)then
!        WRITE(*, '( a6, $)') 'Calls'
!        WRITE(*, '(a23, $)') '|f(x)|               '
!        WRITE(*, '(a23, $)') '|x|                  '
!        WRITE(*,*) ''
!    end if

    fvec(1) = 4*x(1)**2-1

!    WRITE(*, '(    a6, $)') '     '
!    WRITE(*, '(e23.15, $)') DNRM2(n, fvec, 1)
!    WRITE(*, '(e23.15, $)') DNRM2(n, x, 1)
!    WRITE(*, *) ''

end Subroutine fun

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!
