program sfunTest
    use mod_sfun
    implicit none

    double precision                                :: z0(4), ti(2), par(6), s(4), sEtalon(4), res
    type(TOptions)                                  :: options
    integer                                         :: flag,i
    logical                                         :: erreur

    !Affichage des options
!optionsDefaut (Matlab) =
!            Derivative: 'eqvar'
!              DispIter: 1
!               Display: 'on'
!            DoSavePath: 'off'
!         FreeFinalTime: 'false'
!                 MaxSf: 100000
!           MaxSfunNorm: 0.100000000000000
!           MaxStepsOde: 100000
!        MaxStepsOdeHam: 100000
!        MaxStepSizeOde: 0
!     MaxStepSizeOdeHam: 0
!                   ODE: 'dopri5'
!                ODEHam: 'dopri5'
!    StopAtTurningPoint: 0
!             TolOdeAbs: 1.000000000000000e-14
!             TolOdeRel: 1.000000000000000e-08
!          TolOdeHamAbs: 1.000000000000000e-14
!          TolOdeHamRel: 1.000000000000000e-08
!        TolDenseHamEnd: 1.000000000000000e-08
!          TolDenseHamX: 1.000000000000000e-08
!            TolScaling: 1.000000000000000e-05
!                  TolX: 1.000000000000000e-08

!    call printOptions(options)

    ti    = (/ 0d0, 0.1d0 /)
    z0    = (/ -1d0, -1d0, 1d0, 2d0 /)
    par   = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
    call sfun(ti, z0, options, par, s, flag)

    sEtalon = (/ 0d0, 0d0, -1.391637858354299d0,  -48.968474123674980d0 /)

    res = 0d0
    do i=1,size(s)
        res = res + abs(s(i)-sEtalon(i))**2
    end do
    res = sqrt(res)

    erreur = .false.
    if(.not.(res.lt.1d-8))then
        erreur = .true.
    end if

    if(erreur)then
        write(*,*) "   sfun      test failed!"
    else
        write(*,*) "   sfun      test ok!"
    end if

end program sfunTest

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!

