program sjacTest
    use mod_sjac
    implicit none

    double precision   :: z0(4), ti(2), par(6), fjac(4,5), fjacEtalon(4,5), res
    type(TOptions)     :: options
    integer            :: flag,i,indexpar(2),j
    logical            :: erreur

    !Affichage des options
!optionsDefaut (Matlab) =
!            Derivative: 'eqvar'
!              DispIter: 1
!               Display: 'on'
!            DoSavePath: 'off'
!         FreeFinalTime: 'false'
!                 MaxSf: 100000
!           MaxsjacNorm: 0.100000000000000
!           MaxStepsOde: 100000
!        MaxStepsOdeHam: 100000
!        MaxStepSizeOde: 0
!     MaxStepSizeOdeHam: 0
!                   ODE: 'dopri5'
!                ODEHam: 'dopri5'
!    StopAtTurningPoint: 0
!             TolOdeAbs: 1.000000000000000e-14
!             TolOdeRel: 1.000000000000000e-08
!          TolOdeHamAbs: 1.000000000000000e-14
!          TolOdeHamRel: 1.000000000000000e-08
!        TolDenseHamEnd: 1.000000000000000e-08
!          TolDenseHamX: 1.000000000000000e-08
!            TolScaling: 1.000000000000000e-05
!                  TolX: 1.000000000000000e-08

!    call printOptions(options)

    ti       = (/ 0d0, 0.1d0 /)
    z0       = (/ -1d0, -1d0, 1d0, 2d0 /)
    par      = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 10d0/)
    indexpar = (/ 5, 6 /)
    call sjac(ti, z0, options, par, indexpar, fjac, flag)

!fjac =  1.0e+03 *
!   0.001000000000000                   0                   0                   0                   0
!                   0   0.001000000000000                   0                   0                   0
!   0.001000000000000   0.005097224911500  -0.000001287177258   0.000051059755855  -0.000258810803020
!                   0   2.547510834335525  -0.000652078391991   0.025646770919449  -0.143507162788999

    fjacEtalon = 0d0
    fjacEtalon(1,1) =  1d0;                 fjacEtalon(3,1) =  1d0;                 fjacEtalon(2,2) = 1d0;
    fjacEtalon(3,2) =  0.005097224911500d3; fjacEtalon(4,2) =  2.547510834335525d3;
    fjacEtalon(3,3) = -0.000001287177258d3; fjacEtalon(4,3) = -0.000652078391991d3;
    fjacEtalon(3,4) =  0.000051059755855d3; fjacEtalon(4,4) =  0.025646770919449d3;
    fjacEtalon(3,5) = -0.000258810803020d3; fjacEtalon(4,5) = -0.143507162788999d3;

    res = 0d0
    do i=1,size(fjac,1)
        do j=1,size(fjac,2)
            res = res + abs(fjac(i,j)-fjacEtalon(i,j))**2
!            write(*,*) 'fjac(',i,',',j,')=',fjac(i,j), ' res = ', abs(fjac(i,j)-fjacEtalon(i,j))**2
        end do
    end do
    res = sqrt(res)

    erreur = .false.
    if(.not.(res.lt.1d-8))then
        erreur = .true.
    end if

    if(erreur)then
        write(*,*) "   sjac      test failed!"
    else
        write(*,*) "   sjac      test ok!"
    end if

end program sjacTest

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!

