program ssolveTest
    use mod_ssolve
    implicit none

    double precision                                :: z00(4), ti0(2), par(6), ssol(4), res
    double precision                                :: z0sol(4), tisol(4), z0solEtalon(4)
    type(TOptions)                                  :: options
    integer                                         :: flag,i,nfev,njev
    logical                                         :: erreur

    !Affichage des options
!optionsDefaut (Matlab) =
!            Derivative: 'eqvar'
!              DispIter: 1
!               Display: 'on'
!            DoSavePath: 'off'
!         FreeFinalTime: 'false'
!                 MaxSf: 100000
!           MaxSfunNorm: 0.100000000000000
!           MaxStepsOde: 100000
!        MaxStepsOdeHam: 100000
!        MaxStepSizeOde: 0
!     MaxStepSizeOdeHam: 0
!                   ODE: 'dopri5'
!                ODEHam: 'dopri5'
!    StopAtTurningPoint: 0
!             TolOdeAbs: 1.000000000000000e-14
!             TolOdeRel: 1.000000000000000e-08
!          TolOdeHamAbs: 1.000000000000000e-14
!          TolOdeHamRel: 1.000000000000000e-08
!        TolDenseHamEnd: 1.000000000000000e-08
!          TolDenseHamX: 1.000000000000000e-08
!            TolScaling: 1.000000000000000e-05
!                  TolX: 1.000000000000000e-08

!    call printOptions(options)

    call setOption(options,'Display','off')

    ti0    = (/ 0d0, 1d0 /)
    z00    = (/ -1d0, -1d0, 1d0, 2d0 /)
    par    = (/ -1d0, -1d0, 0d0, 0d0, 1d0, 1d0/)
    call ssolve(ti0, z00, options, par, tisol, z0sol, ssol, nfev, njev, flag)

    z0solEtalon = (/ -1d0, -1d0, 47.435672429068852d0, 23.978907896715214d0 /)

    res = 0d0
    do i=1,size(z00)
        res = res + abs(z0sol(i)-z0solEtalon(i))**2 + abs(ssol(i)**2)
    end do
    res = sqrt(res)

    erreur = .false.
    if(.not.(res.lt.1d-8))then
        erreur = .true.
    end if

    if(erreur)then
        write(*,*) "   ssolve    test failed!"
    else
        write(*,*) "   ssolve    test ok!"
    end if

end program ssolveTest

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!


