!!********************************************************************
!>  \ingroup problemDefinition
!!  \brief Parameters wrt to lambda, with lambda from 0 to 1.
!!  \details
!!   The purpose of parfun is to give an homotopic relation between par0 and parf.
!!   By default, it is coded an affine homotopy.
!!  \param[in] lpar     Number of optional parameters
!!  \param[in] lambda   Current homotopic parameter
!!  \param[in] par0     Optional intital parameters
!!  \param[in] parf     Optional final parameters
!!  \param[out] par     Optional parameters at lambda
!!  \author Olivier Cots
!!  \date   2009-2013
!!  \copyright Eclipse Public License
      Subroutine parfun(lambda,lpar,par0,parf,par)
         implicit none
         integer,                           intent(in)  :: lpar
         double precision,                  intent(in)  :: lambda
         double precision, dimension(lpar), intent(in)  :: par0,parf
         double precision, dimension(lpar), intent(out) :: par

         par = (1d0-lambda)*par0 + lambda*parf

      end subroutine parfun

!!******************************************************************************************!!
! Written on 2009-2013                                                                      !!
! by Oivier Cots - Math. Institute, Bourgogne Univ / ENSEEIHT-IRIT / INRIA Sophia-Antipolis !!
!!******************************************************************************************!!
